'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createAvaTest;
function createAvaTest(_ref) {
  var actions = _ref.actions;
  var imports = _ref.imports;
  var reducer = _ref.reducer;
  var equalityFunction = _ref.equalityFunction;

  var asserts = actions.map(function (action, index) {
    return 'test(\'' + action.action.type + ' (action index ' + index + ') should correctly update state\', function(t) {\n  var action = actions[' + index + '];\n  var result = reducer(action.prevState, action.action);\n  t.ok(equality(result, action.nextState));\n});';
  }).join('\n\n');
  return 'var test = require(\'ava\');\n' + imports + '\n' + reducer + '\nvar equality = ' + equalityFunction + ';\nvar actions = ' + JSON.stringify(actions, null, 2) + ';\n\n' + asserts;
}